module Middleman
  module Decorators
    class Extension < ::Middleman::Extension
      option :decorators_path, "decorators", "Path to decorators relative to root"

      def initialize(*args)
        super
        decorators_path = app.root_path.join(options.decorators_path, "*.rb")
        Dir[decorators_path].each do |f|
          require f
        end
      end

      module Helpers
        def decorate(object, class_name)
          class_name.send(:new, object, self)
        end
      end

      helpers Helpers
    end

    ::Middleman::Extensions.register(:decorators, Middleman::Decorators::Extension)
  end
end
